/*
	argv[0] : Output file name of Prime (p, q, g)
*/

import java.math.BigInteger;
import java.util.Random;
import java.io.*;

public class MkKey{

	BigInteger p, q, g;
	Random rnd;

	public  void mkkey(){

		//Read read = new Read(argv[0]);
		//BigInteger[] prime = read.toBigInteger(read.readAll(), 16);
		
		int q_i = 160;//Integer.parseInt(argv[0]);
		int p_i = 576;//Integer.parseInt(argv[1]);
		int pbch = 100000000;//Integer.parseInt(argv[2]);
		MkPrime kg = new MkPrime(q_i, p_i, pbch);
		BigInteger[] prime = kg.mkprime(q_i,p_i,pbch);
		MkKey key = new MkKey(prime);
		BigInteger[] xy = key.make();

		BigInteger p = prime[0];
		BigInteger q = prime[1];
		BigInteger g = prime[2];
		BigInteger x = xy[0];
		BigInteger y = xy[1];

		try{
			PrintWriter pkey = new PrintWriter("key.pk");

			pkey.println(p.toString(16));
			pkey.println(q.toString(16));
			pkey.println(g.toString(16));
			pkey.println(y.toString(16));
			pkey.close();

			PrintWriter skey = new PrintWriter("key.sk");
			skey.println(x.toString(16));
			skey.close();
		}catch(IllegalArgumentException e){
			System.out.println("key_write out");
			System.out.println(e);
		}catch(IOException e){
		}

	}


	MkKey(){
	}


	MkKey(BigInteger[] prime){
		p = prime[0];
		q = prime[1];
		g = prime[2];

		rnd = new Random();
	}


	public BigInteger[] make(){
		BigInteger x = new BigInteger(q.bitLength(), rnd);
		BigInteger y = g.modPow(x, p);

		BigInteger[] a = {x, y};
		return a;
	}

}



class MkPrime{

	int qbit, pbit, CheckPrime;
	Random rnd;

	BigInteger[] mkprime(int q_i,int p_i, int pbch){

		//if(argv.length == 4){

		/*	int q_i = 160//Integer.parseInt(argv[0]);
			int p_i = 576//Integer.parseInt(argv[1]);
			int pbch = //Integer.parseInt(argv[2]);*/
			MkPrime kg = new MkPrime(q_i, p_i, pbch);
			BigInteger[] prime = kg.make();
			BigInteger g = kg.make(prime[0], prime[1]);

			System.out.println("Prime p = " + prime[0].toString(16));
			System.out.println("Prime q = " + prime[1].toString(16));
			System.out.println("Generator g = " + g.toString(16));
			System.out.println("g^q mod p = " + g.modPow(prime[1], prime[0]));

			BigInteger[] pqg = new BigInteger[3];
			pqg[0] = prime[0];
			pqg[1] = prime[1];
			pqg[2] = g;


			/*Write wr = new Write(argv[3]);
			wr.println(prime[0].toString(16));
			wr.println(prime[1].toString(16));
			wr.print(g.toString(16));
			wr.close();
		}else{
			System.out.println("Usage : MkPrime q-bit p-bit Check-time out-put-file");
			System.out.println("\tq-bit : q's bit size");
			System.out.println("\tp-bit : p's bit size");
			System.out.println("\tCheck-time : round of prime check");
			System.out.println("\tout-put-file : out put file name");
		}*/
		return pqg;
	}


	MkPrime(){
	}


	MkPrime(int q_i, int p_i, int pbch){

		qbit = q_i;
		pbit = p_i;
		CheckPrime = pbch;

		rnd = new Random();

	}


	public BigInteger[] make(){

		BigInteger q = new BigInteger("0"), r;
		BigInteger p = new BigInteger("4");
		
		while(p.isProbablePrime(CheckPrime) != true){
			r = new BigInteger(pbit-qbit, rnd);
			while(r.compareTo(BigInteger.ONE) < 0){
				r = new BigInteger(pbit-qbit, rnd);
			}
			q = new BigInteger(qbit, CheckPrime, rnd);
			while(q.compareTo(BigInteger.ONE) < 0){
				q = new BigInteger(qbit, CheckPrime, rnd);
			}
			p = (r.multiply(q)).add(BigInteger.ONE);
		}

		BigInteger[] prime = {p, q};

		return prime;

	}


	public BigInteger make(BigInteger p, BigInteger q){

		BigInteger g0 = new BigInteger(qbit, rnd);
		while(g0.compareTo(BigInteger.ONE) < 0){
			g0 = new BigInteger(qbit, rnd);
		}

		BigInteger g = g0.modPow((p.subtract(BigInteger.ONE)).divide(q), p);
		while(g.compareTo(BigInteger.ONE) == 0){
			g0 = new BigInteger(qbit, rnd);
			while(g0.compareTo(BigInteger.ONE) < 0){
				g0 = new BigInteger(qbit, rnd);
			}
			g = g0.modPow((p.subtract(BigInteger.ONE)).divide(q), p);
		}

		return g;

	}
}



